#attribute_scraper.pl
#pulls all of the attributes out of each image's region data attributes file
#usage: perl attribute_scraper.pl

my @all_dirs;
$all_dirs[0] = "scene_text";
$all_dirs[1] = "scene_text_2";
$all_dirs[2] = "scene_text_3";
my @image_attribute_classes;
my @image_attribute_names;
my $file_count = 0;

foreach $dir (@all_dirs) {
    
    chdir $dir;
    
    my @all_files = glob "*";
    
    foreach $file (@all_files) {
	if ($file =~ m/IMAGE/) {
	    my $is_a_directory = 0;
	    $is_a_directory = 1 if -d $file;
	    
	    unless ($is_a_directory == 1) {
		next;
	    }

	    chdir $file;

	    open ATTRIBUTE_FILE, "<$file" . "_region_data_attributes.txt";

	    my $attribute_count = 0;

	    while (defined($line = <ATTRIBUTE_FILE>)) {
		if ($line =~ m/Attribute Subset Evaluator/) {
		    my @fields = split(/:/, $line);
		    my $interesting = $fields[1];
		    if ($interesting =~ m/(\d+) (\w+)/) {
			$image_attribute_classes[$file_count][$attribute_count] = $1;
			$image_attribute_names[$file_count][$attribute_count] = $2;
		    }
		    
		    $attribute_count += 1;
		}
		
		if ($line =~ m/Selected attributes:/) {
		    my @fields = split(/:/, $line);
		    my @numbers = split(/\,/, $fields[1]);
		    my $count = $fields[2];
		    
		    #pick out all the attribute class numbers
		    for (;$attribute_count < $count + 1;$attribute_count++) {
			if ($numbers[$attribute_count - 1] =~ m/(\d+)/) {
			    $image_attribute_classes[$file_count][$attribute_count] = $1;
			}
		    }
		    
		    #pick out all the attribute names
		    $attribute_count = 1;
		    for (;$attribute_count < $count + 1;$attribute_count++) {
			$line = <ATTRIBUTE_FILE>;
			if ($line =~ m/(\w+)/) {
			    $image_attribute_names[$file_count][$attribute_count] = $1;
			}
		    }
		}
	    }
	    
	    close ATTRIBUTE_FILE;

	    $file_count += 1;
	    chdir "..";
	}
    }
    chdir "..";
}

#do something down here with the classes
my @unique_classes = [];
my @unique_class_count = [];
my @unique_names = [];
my @unique_name_count = [];
my $unique_count = 0;

my $curr_count = 0;
while (defined($image_attribute_classes[$curr_count])) {
    
    my $curr_attribute = 0;
    while(defined($image_attribute_classes[$curr_count][$curr_attribute])) {
	my $curr_class = $image_attribute_classes[$curr_count][$curr_attribute];
	my $curr_name = $image_attribute_names[$curr_count][$curr_attribute];
	
	#keep count of matches between this class and the list of
	#unique classes
	my $curr_index = 0;
	for (; $curr_index < (scalar @unique_classes); $curr_index++) {
	    
	    $class = $unique_classes[$curr_index];
	    if ($class eq $curr_class) {
	        $unique_class_count[$curr_index] += 1;
		$unique_name_count[$curr_index] += 1;
		last;
	    }
	}

	#if we reached the end and had no matches, this is unique
	if ($curr_index == scalar(@unique_classes)) {
	    $unique_classes[$unique_count] = $curr_class;
	    $unique_names[$unique_count] = $curr_name;
	    $unique_class_count[$unique_count] = 1;
	    $unique_name_count[$unique_count] = 1;
	    $unique_count++;
	}
	
	$curr_attribute += 1;	    
    }

    $curr_count += 1;
}

#print out the frequencies of each class and name

for (my $index = 0; defined($unique_classes[$index]); $index++) {
    print "$unique_classes[$index]\t$unique_class_count[$index]\n";
}
for (my $index = 0; defined($unique_names[$index]); $index++) {
    print "$unique_names[$index]\t$unique_name_count[$index]\n";
}
